Attribute VB_Name = "mCore"
Option Explicit

'Declares
    Public Declare Function GetTickCount Lib "kernel32" () As Long
    
    Public Declare Function SetPixelV Lib "gdi32" (ByVal iDC As Long, ByVal x As Long, ByVal y As Long, ByVal iColor As Long) As Long
    Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

'Data type definition
    Public Type tStar
        x As Single
        y As Single
        z As Single
        
        TempX As Long
        TempY As Long
        
        BGColor As Long
    End Type

'The stars array
    Public StarCount As Long
    Public Star() As tStar

'Screen size
    Public ScreenW As Long
    Public ScreenH As Long
    
    Public OffsetX As Long
    Public OffsetY As Long

'Setup
    Public Speed As Single
    
    Public SpreadX As Single
    Public SpreadY As Single
    Public SpreadZ As Single

Public Sub ClearScreen(DC As Long)
    Dim A As Long
    
    'Always clean-up in reversed order
    For A = StarCount To 0 Step -1
        With Star(A)
            'Restore pixel
            SetPixelV DC, .TempX, .TempY, .BGColor
        End With
    Next
End Sub

Public Sub DrawStars(DC As Long)
    Dim A As Long
    
    Dim TempColor As Single
    
    For A = 0 To StarCount
        With Star(A)
            'Get 2D (projected) position
            .TempX = (.x / .z) + OffsetX
            .TempY = (.y / .z) + OffsetY
            
            'Get color from distance
            TempColor = (1 - (.z / SpreadZ)) ^ 2 * 255
            '(Here ^ 2 smooths the fading of darker stars)
            
            'Backup color
            .BGColor = GetPixel(DC, .TempX, .TempY)
            
            'Draw pixel
            SetPixelV DC, .TempX, .TempY, RGB(TempColor * 1, TempColor * 0.8, TempColor * 0.2)
            '(Multiplying the color parts with any value we can change the tint of the stars)
        End With
    Next
End Sub

Public Sub MoveStars()
    Dim A As Long
    
    For A = 0 To StarCount
        With Star(A)
            'Move towards screen
            .z = .z - Speed
            
            If .z <= 0 Then
                'Reset star when in front of screen
                .x = (Rnd - 0.5) * SpreadX
                .y = (Rnd - 0.5) * SpreadY
                .z = SpreadZ
            End If
        End With
    Next
End Sub


Public Sub SetupStars(iCount As Long)
    Dim A As Long
    
    'Create stars array
    StarCount = iCount
    ReDim Star(StarCount)
    
    'Set random positions
    For A = 0 To StarCount
        With Star(A)
            .x = (Rnd - 0.5) * SpreadX
            .y = (Rnd - 0.5) * SpreadY
            .z = Rnd * SpreadZ
        End With
    Next
End Sub


